package zoznamka;

import java.util.HashSet;
import java.util.Set;

public class Osoba {
    private String meno;

    private int vek;

    private boolean pohlavie;

    private String farbaVlasov;

    private Set<String> zaluby = new HashSet<String>();

    public String getFarbaVlasov() {
        return farbaVlasov;
    }

    public void setFarbaVlasov(String farbaVlasov) {
        this.farbaVlasov = farbaVlasov;
    }

    public String getMeno() {
        return meno;
    }

    public void setMeno(String meno) {
        this.meno = meno;
    }

    public boolean isMuz() {
        return pohlavie;
    }

    public boolean isZena() {
        return !pohlavie;
    }

    public boolean isPohlavie() {
        return pohlavie;
    }

    public void setPohlavie(boolean pohlavie) {
        this.pohlavie = pohlavie;
    }

    public int getVek() {
        return vek;
    }

    public void setVek(int vek) {
        this.vek = vek;
    }

    @Override
    public String toString() {
        return "Osoba{" + "meno=" + meno + "vek=" + vek + "pohlavie=" + pohlavie + "farbaVlasov=" + farbaVlasov + "zaluby=" + zaluby + '}';
    }

    public void pridajZalubu(String zaluba) {
        zaluby.add(zaluba);
    }

    public void setMuz() {
        pohlavie = true;
    }

    public void setZena() {
        pohlavie = false;
    }

    public int porovnajSa(Osoba osoba) {
        int skore = 0;

        if(this.pohlavie != osoba.pohlavie) {
            skore = skore + 20000;            
        }

        if(this.farbaVlasov.equals(osoba.farbaVlasov)) {
            skore = skore + 1;
        }

        if(Math.abs(this.vek - osoba.vek) <= 3) {
            skore = skore + 5;
        }

        Set<String> spolocneZaluby = new HashSet<String>(zaluby);
        spolocneZaluby.retainAll(osoba.zaluby);

        skore = skore + (spolocneZaluby.size() * 2);

        return skore;
    }
}
