package zoznamka.gui;

import javax.swing.JOptionPane;
import zoznamka.Osoba;

public class OsobaForm extends javax.swing.JDialog {
    private boolean modalResult;

    /**
     * Model pre formular osoby
     */
    private Osoba osoba;

    /** Creates new form OsobaForm */
    public OsobaForm() {
        this(new Osoba());
    }

    public OsobaForm(Osoba osoba) {
        initComponents();

        this.osoba = osoba;
        
        txtMeno.setText(osoba.getMeno());
        txtVek.setText(Integer.toString(osoba.getVek()));
        if(osoba.isMuz()) {
            cmbPohlavie.setSelectedIndex(0);
        } else {
            cmbPohlavie.setSelectedIndex(1);
        }

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lblMeno = new javax.swing.JLabel();
        lblVek = new javax.swing.JLabel();
        lblPohlavie = new javax.swing.JLabel();
        txtMeno = new javax.swing.JTextField();
        txtVek = new javax.swing.JTextField();
        cmbPohlavie = new javax.swing.JComboBox();
        btnOK = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();

        lblMeno.setText("Meno:");

        lblVek.setText("Vek:");

        lblPohlavie.setText("Pohlavie:");

        cmbPohlavie.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Muž", "Žena" }));

        btnOK.setText("OK");
        btnOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOKActionPerformed(evt);
            }
        });

        btnCancel.setText("Storno");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblPohlavie)
                            .addComponent(lblVek)
                            .addComponent(lblMeno))
                        .addGap(48, 48, 48)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtMeno, javax.swing.GroupLayout.DEFAULT_SIZE, 295, Short.MAX_VALUE)
                            .addComponent(txtVek, javax.swing.GroupLayout.DEFAULT_SIZE, 295, Short.MAX_VALUE)
                            .addComponent(cmbPohlavie, javax.swing.GroupLayout.Alignment.TRAILING, 0, 295, Short.MAX_VALUE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(btnOK, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(btnCancel)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblMeno)
                    .addComponent(txtMeno, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblVek)
                    .addComponent(txtVek, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblPohlavie)
                    .addComponent(cmbPohlavie, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnOK)
                    .addComponent(btnCancel))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOKActionPerformed
        if(txtMeno.getText().trim().length() == 0){
            JOptionPane.showMessageDialog(this, "Zadajte, prosím, meno.");
            return;
        }

        int vek = 0;
        try {
            vek = Integer.parseInt(txtVek.getText());
        } catch(NumberFormatException e) {
            JOptionPane.showMessageDialog(this, "Vek musí byť číslo");
            return;
        }
        
        osoba.setMeno(txtMeno.getText());
        osoba.setVek(vek);

        if(cmbPohlavie.getSelectedItem().equals("Muž")) {
            osoba.setMuz();
        } else {
            osoba.setZena();
        }

        modalResult = true;

        setVisible(false);

    }//GEN-LAST:event_btnOKActionPerformed

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        setVisible(false);
    }//GEN-LAST:event_btnCancelActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new OsobaForm().setVisible(true);
            }
        });
    }

    public Osoba getOsoba() {
        return osoba;
    }

    public boolean showModal() {
        setModal(true);
        setVisible(true);
        
        return modalResult;
    }
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnOK;
    private javax.swing.JComboBox cmbPohlavie;
    private javax.swing.JLabel lblMeno;
    private javax.swing.JLabel lblPohlavie;
    private javax.swing.JLabel lblVek;
    private javax.swing.JTextField txtMeno;
    private javax.swing.JTextField txtVek;
    // End of variables declaration//GEN-END:variables

}
